/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

let devVersion = 0;
let xRange = 0;
let yRange = 0;
let zRange = 0;
let mRange = 0;
let aEnable = 0;
let toggleLEDcur = 0;
let toggleLEDprev = 0;
let toggleLEDstate = 0;
let pushThresh = 90;
let x_msb = 0;
let t_msb = 0;
let y_msb = 0;
let z_msb = 0;
let angle_msb = 0;
let mag_msb = 0;

let saveText = function(fname, text) {
    let blob = new Blob([text], {
        type: 'text/plain;charset=utf-8'
    });
    saveAs(blob, fname);

    return false;
}

let combineData = function(data_msb, data_lsb)
{
    let data_out = (data_msb << 8) + data_lsb;
    return data_out;
}

//Checks if given mT magnitude is in the appropriate range
let checkMagnitude = function(magAngle)
{
    if(magAngle == 1)//XY
    {
        mRange = Math.sqrt(Math.pow(xRange,2)+Math.pow(yRange,2));
        aEnable = 1;
        result = 'Range = 0 to ' + mRange.toFixed(3) +' mT';
        if(xRange == yRange)
        {
            //result = 'Range = ±' + xRange +' mT';
        }
        else
        {
            result = result + ' | Warning: For best results use the same range for X & Y, and adjust with the MAG_GAIN_CONFIG register.';
        }
    }
    else if(magAngle == 2)//YZ
    {
        mRange = Math.sqrt(Math.pow(yRange,2)+Math.pow(zRange,2));
        aEnable = 0;
        result = 'Range = 0 to ' + mRange.toFixed(3) +' mT';
        // if(yRange == zRange)
        // {
        //     result = 'Range = ±' + yRange +' mT';
        // }
        // else
        // {
        //     result = 'WARNING: Y & Z ranges should be the same.';
        // }
    }
    else if(magAngle == 3)//ZX
    {
        mRange = Math.sqrt(Math.pow(zRange,2)+Math.pow(xRange,2));
        aEnable = 0;
        result = 'Range = 0 to ' + mRange.toFixed(3) +' mT';
        // if(xRange == yRange)
        // {
        //     result = 'Range = ±' + zRange +' mT';
        // }
        // else
        // {
        //      result = 'WARNING: Z & X ranges should be the same.';
        // }
    }
    
    // PUSH BUTTON STUFF
    else 
    {
        aEnable = 0;
        result = 'No Angle/Magnitude Calculation';
        templateObj.$.ti_widget_label_rpad.label = 'Device Angle: -----';
    }
    //END OF PUSH BUTTON ELSE

    templateObj.$.ti_widget_label_m.label= result;
    
    return 0;
}

/*
*  Boilerplate code for creating computed data bindings
*/
document.addEventListener('gc-databind-ready', function() 
{
    /* 
	*   Add custom computed value databindings here, using the following method:
	*
    *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
	*
	*   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
	*   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
    */
	
	// For example, a simple computed values based on simple expression
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");
	
	// Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });
	
	// Event 1 to n bindings
    // gc.databind.registry.bind('widget.date.value', 
    //     // dependant bindings needed in order to compute the date, in name/value pairs.
    //     {
    //         weekday: 'widget.dayOfWeek.selectedText',
    //         day: 'widget.dayOfMonth.value',
    //         month: 'widget.month.selectedText',
    //         year: 'widget.year.value'
    //     }, 
    //     // getter for date computation
    //     function(values) 
    //     {
    //         // compute and return the string value to bind to the widget with id 'date'
    //         return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
    //     }
    // ); 
	/**/ 
	
	// X-Axis LSB Binding
    gc.databind.registry.bind('widget.ti_widget_scalargraph_x.value_0',
    
    {  
       // msb: 'register_map.x_msb_result_register.x_ch_result_15_8',
        lsb: 'my_register_model.x_lsb_result_register.x_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            let lsb = value.lsb;
            //let msb = value.msb;
            let result = combineData(x_msb,lsb);
            
            let maxVal = 32767;
            let minVal = -32768;
            
            if(result > maxVal)
            {
                result = result - 0x10000;
                result = -result*xRange/minVal;
            }
            else
            {
               result = result*xRange/maxVal;
            }
            
            return result;
        } 
    );
    
    // X-Axis MSB Binding
    gc.databind.registry.bind('my_register_model.x_msb_result_register.x_ch_result_15_8',
    
    {  
        msb: 'my_register_model.x_msb_result_register.x_ch_result_15_8',
       // lsb: 'my_register_map.x_lsb_result_register.x_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            //let lsb = value.lsb;
               x_msb = value.msb;
            // let result = combineData(msb,lsb);
            
            // let maxVal = 32767;
            // let minVal = -32768;
            
            //  if(result > maxVal)
            //  {
            //     result = result - 0x10000;
            //     result = -result*xRange/minVal;
            //  }
            //  else
            //  {
            //      result = result*xRange/maxVal;
            //  }
            
             return value.msb;
        } 
    );
    
   	// Y-Axis LSB Binding
    gc.databind.registry.bind('widget.ti_widget_scalargraph_y.value_0',
    
    {  
       // msb: 'register_map.x_msb_result_register.x_ch_result_15_8',
        lsb: 'my_register_model.y_lsb_result_register.y_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            let lsb = value.lsb;
            //let msb = value.msb;
            let result = combineData(y_msb,lsb);
            
            let maxVal = 32767;
            let minVal = -32768;
            
            if(result > maxVal)
            {
                result = result - 0x10000;
                result = -result*xRange/minVal;
            }
            else
            {
                result = result*xRange/maxVal;
            }
            
            return result;
        } 
    );
    
    // Y-Axis MSB Binding
    gc.databind.registry.bind('my_register_model.y_msb_result_register.y_ch_result_15_8',
    
    {  
        msb: 'my_register_model.y_msb_result_register.y_ch_result_15_8',
       // lsb: 'my_register_map.y_lsb_result_register.y_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            //let lsb = value.lsb;
               y_msb = value.msb;
            // let result = combineData(msb,lsb);
            
            // let maxVal = 32767;
            // let minVal = -32768;
            
            // if(result > maxVal)
            // {
            //     result = result - 0x10000;
            //     result = -result*xRange/minVal;
            // }
            // else
            // {
            //     result = result*xRange/maxVal;
            // }
            
             return value.msb;
        } 
    );
    
    
    // Z-Axis LSB Binding
    gc.databind.registry.bind('widget.ti_widget_scalargraph_z.value_0',
    
    {  
       // msb: 'register_map.z_msb_result_register.z_ch_result_15_8',
        lsb: 'my_register_model.z_lsb_result_register.z_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            let lsb = value.lsb;
            //let msb = value.msb;
            let result = combineData(z_msb,lsb);
            
            let maxVal = 32767;
            let minVal = -32768;
            
            if(result > maxVal)
            {
                result = result - 0x10000;
                result = -result*zRange/minVal;
            }
            else
            {
                result = result*zRange/maxVal;
            }
            
            return result;
        } 
    );
    
    // Z-Axis MSB Binding
    gc.databind.registry.bind('my_register_model.z_msb_result_register.z_ch_result_15_8',
    
    {  
        msb: 'my_register_model.z_msb_result_register.z_ch_result_15_8',
       // lsb: 'my_register_map.z_lsb_result_register.z_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            //let lsb = value.lsb;
               z_msb = value.msb;
            // let result = combineData(msb,lsb);
            
            // let maxVal = 32767;
            // let minVal = -32768;
            
            // if(result > maxVal)
            // {
            //     result = result - 0x10000;
            //     result = -result*xRange/minVal;
            // }
            // else
            // {
            //     result = result*xRange/maxVal;
            // }
            
             return value.msb;
        } 
    );
    
    // Angle LSB Binding
    gc.databind.registry.bind('widget.ti_widget_scalargraph_a.value_0',
    
    {  
       // msb: 'register_map.z_msb_result_register.z_ch_result_15_8',
        lsb: 'my_register_model.angle_result_lsb_register.angle_result_lsb' ,
     },
        // getter for date computation
        function(value) 
        {
            let lsb = value.lsb;
            //let msb = value.msb;
            let result = combineData(angle_msb,lsb);
            
            let fraction = result & 0xF;
            
            result = result >> 4;
            result = result + fraction/16;
            
            if(aEnable == 1)
            {
                templateObj.$.ti_widget_label_rpad.label = 'Device Angle: ' + result + '°';
            }
            
            return result;
        } 
    );
    
    // Angle MSB Binding
    gc.databind.registry.bind('my_register_model.angle_result_msb_register.angle_result_msb',
    
    {  
        msb: 'my_register_model.angle_result_msb_register.angle_result_msb',
       // lsb: 'my_register_map.z_lsb_result_register.z_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            //let lsb = value.lsb;
               angle_msb = value.msb;
            // let result = combineData(msb,lsb);
            
            // let maxVal = 32767;
            // let minVal = -32768;
            
            // if(result > maxVal)
            // {
            //     result = result - 0x10000;
            //     result = -result*xRange/minVal;
            // }
            // else
            // {
            //     result = result*xRange/maxVal;
            // }
            
             return value.msb;
        } 
    );
    
    
    // Magnitude Binding
     gc.databind.registry.bind('widget.ti_widget_scalargraph_m.value_0', 'my_register_model.magnitude_result_register.magnitude_result', 
        // getter for date computation
        function(value) 
        {
            let result = value;
            let maxVal = 2894.895162; //use xyz chanel max val, for scale
            
            //result = (result*mRange/maxVal); //multiply by 16 for magnitude conversion (from 12 bit xyz chanel values)
            result = ((mRange * result) / Math.pow(2, 7)) / Math.sqrt(2);
            return result;
        }
    ); 
    
    //Temperature LSB Binding
   gc.databind.registry.bind('widget.ti_widget_scalargraph_t.value_0',
    
    {  
       // msb: 'register_map.x_msb_result_register.x_ch_result_15_8',
        lsb: 'my_register_model.t_lsb_result_register.t_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            let lsb = value.lsb;
            //let msb = value.msb;
            let result = combineData(t_msb,lsb);
            
            //result = 65/256*(result/16-1066)+25;
            result = 25 + ((result - 17508) / 60.1);
            //result = result/60.1;
            
            return result;
        } 
    );
    
    //Temperature MSB Binding
    gc.databind.registry.bind('my_register_model.t_msb_result_register.t_ch_result_15_8',
    
    {  
        msb: 'my_register_model.t_msb_result_register.t_ch_result_15_8',
       // lsb: 'my_register_map.x_lsb_result_register.x_ch_result_7_0' ,
     },
        // getter for date computation
        function(value) 
        {
            //let lsb = value.lsb;
               t_msb = value.msb;
            // let result = combineData(msb,lsb);
            
            // let maxVal = 32767;
            // let minVal = -32768;
            
            // if(result > maxVal)
            // {
            //     result = result - 0x10000;
            //     result = -result*xRange/minVal;
            // }
            // else
            // {
            //     result = result*xRange/maxVal;
            // }
            
             return value.msb;
        } 
    );
    
//   gc.databind.registry.bind('widget.ti_widget_scalargraph_a.value_0',
    
//     {  
//         msb: 'register_map.x_msb_result_register.x_ch_result_15_8',
//         lsb: 'register_map.x_lsb_result_register.x_ch_result_7_0' ,
//      },
//         // getter for date computation
//         function(value) 
//         {
//             let lsb = value.lsb;
//             let msb = value.msb;
//             let result = combineData(msb,lsb);
            
//             let maxVal = 32767;
//             let minVal = -32768;
            
//             if(result > maxVal)
//             {
//                 result = result - 0x10000;
//                 result = -result*xRange/minVal;
//             }
//             else
//             {
//                 result = result*xRange/maxVal;
//             }
            
//             return result;
//         } 
//     );
    
    
   gc.databind.registry.bind('widget.ti_widget_label_x.label',
        // dependant bindings needed
        {
            range: 'my_register_model.sensor_config_2_register.x_y_range',
            version: 'my_register_model.device_id_register',
            magAngle: 'my_register_model.sensor_config_2_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            
            if(values.version == 2 )//A2
            {
                if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else 
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }
               
            }
             else if (values.version == 1) //A1
             {
                 if(values.range == 1)
                 {
                     result = 'Range = ±80 mT';
                     range = 80;
                 }
                 else 
                 {
                     result = 'Range = ±40 mT';
                     range = 40;
                 }
    
             }
             
             else //If no device ID is programmed, default to A2
             {
              if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }   
             }
            
            xRange = range;
            
            checkMagnitude(values.magAngle);
            
            return result;
        }
    ); 
    gc.databind.registry.bind('widget.ti_widget_label_y.label',
        // dependant bindings needed
        {
            range: 'my_register_model.sensor_config_2_register.x_y_range',
            version: 'my_register_model.device_id_register',
            magAngle: 'my_register_model.sensor_config_2_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            
            if(values.version == 2 )//A2
            {
                if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else 
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }
               
            }
             else if (values.version == 1) //A1
             {
                 if(values.range == 1)
                 {
                     result = 'Range = ±80 mT';
                     range = 80;
                 }
                 else
                 {
                     result = 'Range = ±40 mT';
                     range = 40;
                 }
    
             }
             
             else //If no device ID is programmed, default to A2
             {
              if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }   
             }
            
            yRange = range;
            
            checkMagnitude(values.magAngle);
            
            return result;
        }
    ); 
    gc.databind.registry.bind('widget.ti_widget_label_z.label',
        // dependant bindings needed
        {
            range: 'my_register_model.sensor_config_2_register.z_range',
            version:'my_register_model.device_id_register',
            magAngle: 'my_register_model.sensor_config_2_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            
            if(values.version == 2 )//A2
            {
                if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }
               
            }
             else if (values.version == 1) //A1
             {
                 if(values.range == 1)
                 {
                     result = 'Range = ±80 mT';
                     range = 80;
                 }
                 else
                 {
                     result = 'Range = ±40 mT';
                     range = 40;
                 }
    
             }
             
             else //If no device ID is programmed, default to A2
             {
                  if(values.range == 1)
                {
                    result = 'Range = ±266 mT';
                    range = 266;
                }
                else
                {
                    result = 'Range = ±133 mT';
                    range = 133;
                }
             }
            
            zRange = range;
            
            checkMagnitude(values.magAngle);
            
            return result;
        }
    ); 


 
    gc.databind.registry.bind('widget.ti_widget_angledisplay_rpd.value',
        // dependant bindings needed
        {
            x_lsb: 'my_register_model.x_lsb_result_register.x_ch_result_7_0' ,
            y_lsb: 'my_register_model.y_lsb_result_register.y_ch_result_7_0' ,
    
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let xData;
            let yData;
            let angle;
            let x_lsb = values.x_lsb;
            let y_lsb = values.y_lsb;
            let x_combined=combineData(x_msb,x_lsb);
            let y_combined=combineData(y_msb,y_lsb);
            let pi = Math.PI;
            
            let maxVal = 32767;
            let minVal = -32768;
            
            if(x_combined > maxVal)
            {
                xData = x_combined - 0x10000;
                xData = -xData*xRange/minVal;
            }
            else
            {
                xData = x_combined*xRange/maxVal;
            }
            
            if(y_combined > maxVal)
            {
                yData = y_combined - 0x10000;
                yData = -yData*yRange/minVal;
            }
            else
            {
                yData = y_combined*yRange/maxVal;
            }
            
            angle = Math.atan2(yData, xData); //Don't need to normalize becuase x and y are assumed to have the same peak values.
            angle = angle * (180/pi);
            
            if (angle < 0)
            {
                angle = angle + 360;
            }
            
            
             angle = angle.toFixed(2);
            
            //PUSH BUTTON DEFINITIONS
            templateObj.$.ti_widget_label_rpa.label = 'Calc Angle: ' + angle + '°';
            //templateObj.$.ti_widget_angledisplay_rpd.value = angle;
            return angle;
            //END OF PUSH BUTTON DEFINITIONS
            
            //toggleLEDprev = toggleLEDcur;
            
            // if(xData > pushThresh | yData > pushThresh | xData < -pushThresh | yData < -pushThresh)
            // {
                // result = 1;
                // toggleLEDcur = 1;
            // }
            // else
            // {
            //      result = 0;
            //     // toggleLEDcur = 0;
            // // }
            
            // // if ((toggleLEDcur != toggleLEDprev) & toggleLEDcur == 1)
            // // {
            //     // if (toggleLEDstate == 1)
            //     // {
            //         // templateObj.$.ti_tile_led1.value = 0;
            //         // toggleLEDstate = 0;
            //     // }
            //     // else 
            //     // {
            //         // templateObj.$.ti_tile_led1.value = 1;
            //         // toggleLEDstate = 1;
            //     // }
            // // }
			
            
            // return result;
        }
    ); 

});

/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});

/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});


/*
*  Boilerplate code for working with components in the application gist
*/
/**/

var initComplete = false;
var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
//widget click events
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId
            
            templateObj.$.ti_widget_button_cx.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_x.reset();
                templateObj.$.ti_widget_scalargraph_x.value_0Changed();
                templateObj.$.ti_widget_scalargraph_x.reset();
            });
            templateObj.$.ti_widget_button_sx.addEventListener("click", function (event) 
            {
                let result = "Sample,X Channel Results (mT)\n";
                let strData = templateObj.$.ti_widget_scalargraph_x.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("xChannelResults.csv", result);
            });
            
            templateObj.$.ti_widget_button_cy.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_y.reset();
                templateObj.$.ti_widget_scalargraph_y.value_0Changed();
                templateObj.$.ti_widget_scalargraph_y.reset();
            });
            templateObj.$.ti_widget_button_sy.addEventListener("click", function (event) 
            {
                let result = "Sample,Y Channel Results (mT)\n";
                let strData = templateObj.$.ti_widget_scalargraph_y.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("yChannelResults.csv", result);
            });
            
            templateObj.$.ti_widget_button_cz.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_z.reset();
                templateObj.$.ti_widget_scalargraph_z.value_0Changed();
                templateObj.$.ti_widget_scalargraph_z.reset();
            });
            templateObj.$.ti_widget_button_sz.addEventListener("click", function (event) 
            {
                let result = "Sample,Z Channel Results (mT)\n";
                let strData = templateObj.$.ti_widget_scalargraph_z.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("zChannelResults.csv", result);
            });
            
            templateObj.$.ti_widget_button_ca.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_a.reset();
                templateObj.$.ti_widget_scalargraph_a.value_0Changed();
                templateObj.$.ti_widget_scalargraph_a.reset();
            });
            templateObj.$.ti_widget_button_sa.addEventListener("click", function (event) 
            {
                let result = "Sample,Angle Results (°)\n";
                let strData = templateObj.$.ti_widget_scalargraph_a.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("anglelResults.csv", result);
            });
            
            templateObj.$.ti_widget_button_cm.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_m.reset();
                templateObj.$.ti_widget_scalargraph_m.value_0Changed();
                templateObj.$.ti_widget_scalargraph_m.reset();
            });
            templateObj.$.ti_widget_button_sm.addEventListener("click", function (event) 
            {
                let result = "Sample,Magnitude Results (mT)\n";
                let strData = templateObj.$.ti_widget_scalargraph_m.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("magnitudeResults.csv", result);
            });
            
            templateObj.$.ti_widget_button_ct.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph_t.reset();
                templateObj.$.ti_widget_scalargraph_t.value_0Changed();
                templateObj.$.ti_widget_scalargraph_t.reset();
            });
            templateObj.$.ti_widget_button_st.addEventListener("click", function (event) 
            {
                let result = "Sample,Temperature Results (°C)\n";
                let strData = templateObj.$.ti_widget_scalargraph_t.series_0_values;
                for (let i = 0; i < strData.length; i++) 
                {
                    result = result + i + "," + strData[i] + "\n";
                }
                saveText("temperatureResults.csv", result);
            });
            
            templateObj.$.ti_widget_textbox_cal.addEventListener("changed", function (event) 
            {
                pushThresh = templateObj.$.ti_widget_textbox_cal.value;
            });
            
            // templateObj.$.ti_widget_enableRP.addEventListener("click", function (event) 
            // {
            //     //Calls function that configures the correct Registers for RNP feature
               
            //     icObject.configureRP();
               
            // });
            
        },1);

	});
};


templateObj = document.querySelector('#template_obj');
if (templateObj) {
    
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this));
}


